"use strict";
//! Credit goes to https://stackoverflow.com/a/44123368/4554883
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const defer_1 = __importDefault(require("./defer"));
function otag(observable) {
    return __asyncGenerator(this, arguments, function* otag_1() {
        let deferred = defer_1.default();
        let finished = false;
        const subscription = observable.subscribe({
            next(value) {
                setImmediate(() => {
                    const result = deferred;
                    deferred = defer_1.default();
                    result.resolve(value);
                });
            },
            error(error) {
                setImmediate(() => {
                    const result = deferred;
                    deferred = defer_1.default();
                    result.reject(error instanceof Error ? error : new Error(String(error)));
                });
            },
            complete() {
                setImmediate(() => {
                    finished = true;
                    deferred.resolve();
                });
            },
        });
        try {
            while (true) {
                const value = yield __await(deferred);
                if (finished)
                    break;
                yield yield __await(value);
            }
        }
        finally {
            subscription.unsubscribe();
        }
    });
}
exports.default = otag;
//# sourceMappingURL=index.js.map